#ifndef FIELD_H
#define FIELD_H
#include "MMASSDefs.h"
#include <string>

namespace MMASS {
	using std::string;

	class Field {
	public:
		virtual ~Field() = 0;

		virtual spField createField(double value_) = 0;
		virtual double diffusion(spSite source, double generatedValue, spSite destiny) = 0;
		virtual double compose(double value1, double value2) = 0;
		virtual bool compare(double value1, double value2) = 0;

		virtual const string getIdentifier() = 0;

		double valuePerceivedForAgent(spAgent agent);
		double getValue();

	protected:
		double value;

		Field(double value_);

	private:
	};
}

#endif