#include "TestFunctions.h"
#define NUMROWS 35
#define NUMCOLS 35

class Vector3 {
public:
	Vector3(int x, int y, int z) { this->x = x; this->y = y; this->z = z; }
	Vector3(const Vector3 &v) {
		this->x = v.x;
		this->y = v.y;
		this->z = v.z;
	}

	float x, y, z;

	bool operator==(const Vector3 &v) {
		return ((this->x == v.x) && (this->y == v.y) && (this->z == v.z));
	}
};

const std::string _getSiteName(const Vector3 &v) {
	char name[6];
	int x = v.x;
	int z = v.z;
	int i = (x + 5) / 10;
	int j = (z + 5) / 10;
	sprintf(name,"%dx%d", i, j);

	return string(name);
}

Vector3 _getPosition(const string &name) {
	const char *n = name.c_str();
	char num[3];

	int i;
	for (i = 0; n[i] != 'x'; i++) num[i] = n[i];
	num[i++] = '\0';

	int x = atoi(num);

	int j = 0;
	for (; i < name.size(); i++, j++) num[j] = n[i];
	num[j] = '\0';
	
	int z = atoi(num);

	return Vector3((10 * x) - 5, 5, (10 * z) - 5);
}

void TestFunctions::run() {
	testFunctions();
}

void TestFunctions::testFunctions() {
	Vector3 v1(15,5,5);

	test_(_getSiteName(v1) == "2x1");
	test_(_getPosition("2x1") == v1);

	for (int i = 1; i <= NUMROWS; i++) {
		for (int j = 1; j <= NUMCOLS; j++) {
			char name[6];
			sprintf(name, "%dx%d", i, j);

			test_(_getSiteName(_getPosition(string(name))) == string(name));

			Vector3 v((i*10)-5, 5, (j*10)-5);
			test_(v == _getPosition(string(name)));
		}
	}
}